
    <!DOCTYPE html>
    <html>
      <head>
        <meta charset="utf-8">
      </head>
      <body>
   
        <div class="marpit"><svg data-marpit-svg="" viewBox="0 0 1280 5000"><foreignObject width="1280" height="5000"><section id="1" data-marpit-fragments="17">
<h1>Деплой</h1>
<p>В этом домашнем задании мы научимся обрабатывать строку запроса и выполнять деплой приложения. Деплой — процесс выкладки приложения на сервер (или сервера). В результате к приложению можно будет доступ через браузер. Для выполнения домашнего задания понадобятся утилиты <em>git</em> и <em>heroku</em> и зарегистрированный аккаунт на <a href="https://www.heroku.com/">heroku</a>.</p>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="https://ru.hexlet.io/courses/http_protocol/lessons/query_string/theory_unit">Урок Передача данных query string</a></li>
<li data-marpit-fragment="2"><a href="https://devcenter.heroku.com/articles/heroku-cli#download-and-install">Установка утилиты Heroku</a></li>
<li data-marpit-fragment="3"><a href="https://www.heroku.com/">Сайт heroku</a></li>
<li data-marpit-fragment="4"><a href="https://devcenter.heroku.com/articles/create-a-java-web-application-using-embedded-tomcat#deploy-to-heroku">Деплой на heroku</a></li>
</ul>
<h2>servlet/CompaniesServlet.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="5">
<p>Реализуйте логику метода <code>doGet()</code>, который должен отображать список компаний в зависимости от параметров запроса. Список всех доступных компаний генерируется методом <code>getCompanies()</code> (уже импортирован в модуль). При выводе списка компаний, сортировать их дополнительно не требуется.</p>
<ul>
<li data-marpit-fragment="6">
<p>Если строка запроса содержит параметр <code>search</code>, то должен выводиться список только тех компаний, которые содержат в имени переданное значение.</p>
<pre><code class="language-text">http://localhost:5000/companies?search=ov

Cartwright-Glover and Sons
Hermann, Macejkovic and Brekke Group
</code></pre>
</li>
<li data-marpit-fragment="7">
<p>Если значение параметра <code>search</code> отсутствует в именах компаний, то должна выводиться строка <code>Companies not found</code>.</p>
<pre><code class="language-text">http://localhost:5000/companies?search=tl

Companies not found
</code></pre>
</li>
<li data-marpit-fragment="8">
<p>В случае отсутствия в строке запроса параметра <code>search</code> или если значением является пустая строка — должны выводиться все компании. Подробнее смотрите примеры.</p>
<pre><code class="language-text">http://localhost:5000/companies?search=
http://localhost:5000/companies

&lt;список полностью всех компаний&gt;
</code></pre>
</li>
</ul>
</li>
</ul>
<h2>Подсказки</h2>
<ul>
<li data-marpit-fragment="9">Для работы со строкой запроса вам понадобится использовать методы <a href="https://javaee.github.io/javaee-spec/javadocs/javax/servlet/ServletRequest.html#getParameter-java.lang.String-">getParameter()</a> и <a href="https://javaee.github.io/javaee-spec/javadocs/javax/servlet/http/HttpServletRequest.html#getQueryString--">getQueryString()</a>.</li>
</ul>
<h2>App.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="10">Зарегистрируйте в контейнере tomcat сервлет <code>CompaniesServlet</code>, так чтобы он обрабатывал запросы по пути <code>/companies</code>. Для проверки работы приложения запустите сервер, используя команду <code>make start</code>. Приложение в браузере будет доступно по адресу <em><a href="http://localhost:5000">http://localhost:5000</a></em></li>
</ul>
<h2>build.gradle</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="11">
<p>В процессе деплоя heroku с помощью gradle будет запускать задачу <em>stage</em>, которую необходимо создать. В простейшем случае задача <em>stage</em> должна выполнять установку приложения (задачу <em>install</em>), но без запуска тестов — это можно сделать вызвав задачу <em>installDist</em>. Добавим задачу <em>stage</em> с нужной логикой:</p>
<pre><code class="language-java"><span class="hljs-function">task <span class="hljs-title">stage</span><span class="hljs-params">(dependsOn: [<span class="hljs-string">&#x27;clean&#x27;</span>, <span class="hljs-string">&#x27;installDist&#x27;</span>])</span>
installDist.mustRunAfter clean
</span></code></pre>
</li>
</ul>
<h2>Procfile</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="12">
<p>После успешной компиляции и сборки проекта на heroku, приложение нужно запустить. Это можно сделать если указать heroku команду которую нужно выполнить. Добавьте команду запуска исполняемого файла:</p>
<pre><code class="language-bash">web: sh build/install/deploy/bin/deploy
</code></pre>
</li>
</ul>
<h2>Gradle Wrapper</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="13">
<p>В процессе деплоя heroku автоматически определит, что используется проект gradle. Но для корректной работы, heroku необходимо использовать нужные версии gradle и java. Иначе будут использоваться версии по умолчанию, которые морально устарели, и с большой долей вероятности деплой завершится с ошибкой.</p>
<p>Зафиксировать нужную версию gradle можно с помощью, так называемого Wrapper (локальной для проекта копии Gradle). Для этого выполните в директории домашнего задания команду:</p>
<pre><code class="language-bash">gradle wrapper --gradle-version 7.2
</code></pre>
<p>Указать целевую версию java можно с помощью конфигурации в файле <em>system.properties</em>:</p>
<pre><code class="language-text">java.runtime.version=16
</code></pre>
</li>
</ul>
<h2>Деплой</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="14">Зарегистрируйте бесплатный аккаунт на <a href="https://www.heroku.com/">heroku</a>.</li>
<li data-marpit-fragment="15">В директории с домашним заданием выполните последовательно команды, как показано в <a href="https://devcenter.heroku.com/articles/create-a-java-web-application-using-embedded-tomcat#deploy-to-heroku">руководстве по деплою</a></li>
<li data-marpit-fragment="16">После открытия задеплоенного приложения в браузере убедитесь, что оно работает.</li>
<li data-marpit-fragment="17">При сдаче домашнего задания укажите ссылку на задеплоенное приложение.</li>
</ul>
</section>
<script>!function(){"use strict";const t="marpitSVGPolyfill:setZoomFactor,",e=Symbol();let r,o;function n(n){const i="object"==typeof n&&n.target||document,a="object"==typeof n?n.zoom:n;window[e]||(Object.defineProperty(window,e,{configurable:!0,value:!0}),window.addEventListener("message",(({data:e,origin:r})=>{if(r===window.origin)try{if(e&&"string"==typeof e&&e.startsWith(t)){const[,t]=e.split(","),r=Number.parseFloat(t);Number.isNaN(r)||(o=r)}}catch(t){console.error(t)}})));let l=!1;Array.from(i.querySelectorAll("svg[data-marpit-svg]"),(t=>{var e,n,i,s;t.style.transform||(t.style.transform="translateZ(0)");const c=a||o||t.currentScale||1;r!==c&&(r=c,l=c);const d=t.getBoundingClientRect(),{length:u}=t.children;for(let r=0;r<u;r+=1){const o=t.children[r],a=o.getScreenCTM();if(a){const t=null!==(n=null===(e=o.x)||void 0===e?void 0:e.baseVal.value)&&void 0!==n?n:0,r=null!==(s=null===(i=o.y)||void 0===i?void 0:i.baseVal.value)&&void 0!==s?s:0,l=o.firstElementChild,{style:u}=l;u.transformOrigin||(u.transformOrigin=`${-t}px ${-r}px`),u.transform=`scale(${c}) matrix(${a.a}, ${a.b}, ${a.c}, ${a.d}, ${a.e-d.left}, ${a.f-d.top}) translateZ(0.0001px)`}}})),!1!==l&&Array.from(i.querySelectorAll("iframe"),(({contentWindow:e})=>{null==e||e.postMessage(`${t}${l}`,"null"===window.origin?"*":window.origin)}))}r=1,o=void 0;const i=(t,e,r)=>{if(t.getAttribute(e)!==r)return t.setAttribute(e,r),!0};function a({once:t=!1,target:e=document}={}){const r="Apple Computer, Inc."===navigator.vendor?[n]:[];let o=!t;const a=()=>{for(const t of r)t({target:e});!function(t=document){Array.from(t.querySelectorAll('svg[data-marp-fitting="svg"]'),(t=>{var e;const r=t.firstChild,o=r.firstChild,{scrollWidth:n,scrollHeight:a}=o;let l,s=1;if(t.hasAttribute("data-marp-fitting-code")&&(l=null===(e=t.parentElement)||void 0===e?void 0:e.parentElement),t.hasAttribute("data-marp-fitting-math")&&(l=t.parentElement),l){const t=getComputedStyle(l),e=Math.ceil(l.clientWidth-parseFloat(t.paddingLeft||"0")-parseFloat(t.paddingRight||"0"));e&&(s=e)}const c=Math.max(n,s),d=Math.max(a,1),u=`0 0 ${c} ${d}`;i(r,"width",`${c}`),i(r,"height",`${d}`),i(t,"preserveAspectRatio",getComputedStyle(t).getPropertyValue("--preserve-aspect-ratio")||"xMinYMin meet"),i(t,"viewBox",u)&&t.classList.toggle("__reflow__")}))}(e),o&&window.requestAnimationFrame(a)};return a(),()=>{o=!1}}const l=Symbol(),s=document.currentScript;((t=document)=>{if("undefined"==typeof window)throw new Error("Marp Core's browser script is valid only in browser context.");if(t[l])return t[l];const e=a({target:t}),r=()=>{e(),delete t[l]};Object.defineProperty(t,l,{configurable:!0,value:r})})(s?s.getRootNode():document)}();
</script></foreignObject></svg></div>
      </body>
    </html>
  